<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <draggable
    class="row"
    ghost-class="ghost-dragdrop"
    :list="attributes"
    :disabled="!is_reorder"
    @change="onChange"
  >
    <div class="col-sm-6 py-2" v-for="(attribute, index) of attributes" :key="index">
      <div
        class="form-group m-form__group nt-attribute-item"
        style="margin: 0"
        :class="{
          'nt-details-customer-no-update': detailCustomer.deleted_at || 
          (attribute.type_update === 2 || attribute.attribute_code ===  'nt_assigners') && !accessible( userCheckAddOn, 'customer', PERMISSION_UPDATE_CUSTOMER_GENERAL, userCurrentPermissions) ||
          attribute.type_update === 3 && !accessible( userCheckAddOn, 'customer', PERMISSION_UPDATE_CUSTOMER_BUYER, userCurrentPermissions) ||
          attribute.type_update === 4 && !accessible( userCheckAddOn, 'customer', PERMISSION_UPDATE_CUSTOMER_END_USER, userCurrentPermissions), 
          'reorder-label': is_reorder, 
          'has-danger': errors.has(scope + '.' + attribute.attribute_code) || server_errors[attribute.attribute_code] 
          }"
      >
        <div
          v-if="is_reorder"
          class="d-flex align-items-center justify-content-center reorder-icon"
        >
          <i class="icon icon-dragdrop"></i>
        </div>
        <label
          style="font-weight: 500"
          class="form-control-label"
          :class="{ 'reorder-text': is_reorder }"
          :for="attribute.attribute_code"
        >
          {{ attribute.attribute_name }}
          <span
            class="m--font-danger"
            v-if="attribute.is_required && !is_reorder && attribute.attribute_code !== 'sku'"
          >*</span>
        </label>
        <template v-if="!is_reorder">
          <div v-if="attribute.data_type.id">
            <template v-if="attribute.attribute_code === 'sku'">
              <div
                class="form-control nt-form-control-sm nt-border-none pl-0 pr-0"
              >{{ attribute.attribute_value }}</div>
            </template>

            <template v-else-if="attribute.attribute_code === 'nt_created_at'">
              <div
                class="form-control nt-form-control-sm nt-border-none pl-0 pr-0"
              >{{ attribute.attribute_value | formatDateTime }}</div>
            </template>

            <template v-else-if="attribute.attribute_code === 'nt_updated_at'">
              <div
                class="form-control nt-form-control-sm nt-border-none pl-0 pr-0"
              >{{ attribute.attribute_value | formatDateTime }}</div>
            </template>

            <template v-else-if="attribute.attribute_code === 'nt_creator_id'">
              <div class="form-control nt-form-control-sm nt-border-none pl-0 pr-0">
                <user-object-loading
                  :user_id="attribute.attribute_value"
                  :class="'nt-user-form-control-sm'"
                ></user-object-loading>
              </div>
            </template>

            <template v-else-if="attribute.attribute_code === 'nt_assigners'">
              <template v-if="editAttributes[attribute.attribute_code]">
                <v-select
                  v-model="detailCustomer.assigners"
                  label="full_name"
                  :options="listUsers"
                  index="id"
                  multiple
                  id="nt_assigners"
                  name="nt_assigners"
                  class="nt-form-control-sm"
                >
                  <span slot="no-options">Không tìm thấy</span>
                  <template slot="option" slot-scope="option">
                    <b>{{ option.full_name | truncateWords }}</b>
                    <br />
                    {{ option.email | truncateWords }}
                  </template>
                </v-select>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value && attribute.attribute_value.length">
                    <div
                      class="input-group"
                      v-for="(value_item, indexB) in attribute.attribute_value"
                      :key="indexB"
                    >
                      <user-object-loading :user_id="value_item" :class="'nt-user-form-control-sm'"></user-object-loading>
                    </div>
                  </span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isText">
              <template v-if="editAttributes[attribute.attribute_code]">
                <input
                  class="form-control nt-form-control-sm"
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false, max: 250 }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @keyup="changeDataInputType(attribute, $event)"
                  @blur="hideUpdate(attribute)"
                />
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value">{{ attribute.attribute_value }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isDate">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-input-date
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @change="changeDataInputType(attribute)"
                  class="nt-form-control-sm"
                ></s-input-date>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ attribute.attribute_value | formatDateTime }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isDateTime">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-input-date-time
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @change="changeDataInputType(attribute)"
                  class="nt-form-control-sm"
                ></s-input-date-time>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ attribute.attribute_value | formatDateTime(false) }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isPhone">
              <template v-if="editAttributes[attribute.attribute_code]">
                <input
                  class="form-control nt-form-control-sm"
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexPhone() }"
                  v-mask="'#### ### #####'"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @keyup="changeDataInputType(attribute, $event)"
                  @blur="hideUpdate(attribute)"
                />
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ attribute.attribute_value | formatPhone }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isEmail">
              <template v-if="editAttributes[attribute.attribute_code]">
                <input
                  class="form-control nt-form-control-sm"
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false, regex: helpers.regexEmail(), max: 250 }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @keyup="changeDataInputType(attribute, $event)"
                  @blur="hideUpdate(attribute)"
                />
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value">{{ attribute.attribute_value }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isNumber">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-input-number-custom
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @keyup="changeDataInputType(attribute)"
                  @blur="hideUpdate(attribute)"
                  class="nt-form-control-sm"
                ></s-input-number-custom>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ attribute.attribute_value | formatNumber }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isPrice">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-input-number-custom
                  :is_decimal="false"
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @keyup="changeDataInputType(attribute)"
                  @blur="hideUpdate(attribute)"
                  class="nt-form-control-sm"
                ></s-input-number-custom>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ attribute.attribute_value | formatNumberPrice }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isTextArea">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-textarea
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false, max: 1025 }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  @keyup="changeDataInputType(attribute)"
                  @blur="hideUpdate(attribute)"
                  class="nt-form-control-sm"
                ></s-textarea>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                    style="white-space: pre-line; word-break: break-word;"
                    v-html="attribute.attribute_value"
                  ></span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isSelect">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-select
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data="attribute.attribute_options"
                  :label="'option_value'"
                  @change="changeDataInputType(attribute)"
                  @blur="hideUpdate(attribute)"
                  class="nt-form-control-sm"
                ></s-select>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ helpers.getAttributeOption(attribute, attribute.attribute_value, 'option_value') }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isSelectFind">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-select-search
                  :data-vv-scope="scope"
                  v-model.number="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data="attribute.attribute_options"
                  :label="'option_value'"
                  @change="changeDataInputType(attribute)"
                  @blur="hideUpdate(attribute)"
                  class="nt-form-control-sm"
                ></s-select-search>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ helpers.getAttributeOption(attribute, attribute.attribute_value, 'option_value') }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isRadio">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-radio-multiple
                  :data-vv-scope="scope"
                  :col="'col-md-6'"
                  v-model="attribute.attribute_value"
                  :label="'option_value'"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data="attribute.attribute_options"
                  @keyup="changeDataInputType(attribute)"
                  @blur="changeDataInputType(attribute)"
                  class="nt-form-control-sm h-auto"
                ></s-radio-multiple>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm h-auto"
                  @click="showUpdate(attribute)"
                >
                  <span
                    v-if="attribute.attribute_value"
                  >{{ helpers.getAttributeOption(attribute, attribute.attribute_value, 'option_value') }}</span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isMultipleSelect">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-select-multiple
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data="attribute.attribute_options"
                  :label="'option_value'"
                  @change="changeDataInputType(attribute)"
                  class="nt-form-control-sm"
                ></s-select-multiple>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value && attribute.attribute_value.length">
                    <span
                      class="nt-barge-dropdown m--margin-right-5 m--margin-bottom-5"
                      v-for="(item, indexA) in attribute.attribute_value"
                      :key="indexA"
                    >{{ helpers.getAttributeOption(attribute, parseInt(item), 'option_value') | truncateWords }}</span>
                  </span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isCheckboxMultiple">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-checkbox-multiple
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data="attribute.attribute_options"
                  :label="'option_value'"
                  @keyup="changeDataInputType(attribute)"
                  class="nt-form-control-sm h-auto"
                ></s-checkbox-multiple>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm h-auto"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value && attribute.attribute_value.length">
                    <span
                      class="nt-barge-dropdown m--margin-right-5 m--margin-bottom-5"
                      v-for="(item, indexA) in attribute.attribute_value"
                      :key="indexA"
                    >{{ helpers.getAttributeOption(attribute, parseInt(item), 'option_value') | truncateWords }}</span>
                  </span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isTag">
              <template v-if="editAttributes[attribute.attribute_code]">
                <s-tags
                  :data-vv-scope="scope"
                  v-model="attribute.attribute_value"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data="attribute.attribute_options"
                  :label="'option_value'"
                  @change="changeDataInputType(attribute)"
                  class="nt-form-control-sm"
                ></s-tags>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value && attribute.attribute_value.length">
                    <span
                      class="nt-barge-dropdown m--margin-right-5 m--margin-bottom-5"
                      v-for="(item, indexA) in attribute.attribute_value"
                      :key="indexA"
                    >{{ helpers.getAttributeOption(attribute, parseInt(item), 'option_value') | truncateWords }}</span>
                  </span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>
            <template v-else-if="attribute.data_type.id == isUser">
              <template v-if="editAttributes[attribute.attribute_code]">
                <v-select
                  v-model="attribute.attribute_value"
                  label="full_name"
                  :options="listUsers"
                  index="id"
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data-vv-scope="scope"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  @change="changeDataInputType(attribute)"
                  class="nt-form-control-sm"
                >
                  <template slot="option" slot-scope="option">
                    <b>{{ option.full_name | truncateWords }}</b>
                    <br />
                    {{ option.email | truncateWords }}
                  </template>
                </v-select>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value">
                    <user-object-loading
                      :user_id="attribute.attribute_value"
                      :class="'nt-user-form-control-sm'"
                    ></user-object-loading>
                  </span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>

            <template v-else-if="attribute.data_type.id == isUserMultiple">
              <template v-if="editAttributes[attribute.attribute_code]">
                <v-select
                  v-model="attribute.attribute_value"
                  label="full_name"
                  :options="listUsers"
                  index="id"
                  multiple
                  :id="attribute.attribute_code"
                  :name="attribute.attribute_code"
                  :data-vv-scope="scope"
                  v-validate="{ required: attribute.is_required ? true : false }"
                  @change="changeDataInputType(attribute)"
                  class="nt-form-control-sm"
                >
                  <template slot="option" slot-scope="option">
                    <b>{{ option.full_name | truncateWords }}</b>
                    <br />
                    {{ option.email | truncateWords }}
                  </template>
                </v-select>
              </template>
              <template v-else>
                <div
                  class="nt-details form-control nt-form-control-sm"
                  @click="showUpdate(attribute)"
                >
                  <span v-if="attribute.attribute_value && attribute.attribute_value.length">
                    <span
                      class="input-group"
                      v-for="(value_item, indexB) in attribute.attribute_value"
                      :key="indexB"
                    >
                      <user-object-loading :user_id="value_item" :class="'nt-user-form-control-sm'"></user-object-loading>
                    </span>
                  </span>
                  <span v-else class="not-value">Chưa cập nhật</span>
                  <span class="input-icon">
                    <i class="icon icon-edit"></i>
                  </span>
                </div>
              </template>
            </template>
          </div>
          <div
            class="form-control-feedback m--font-danger"
            v-if="server_errors != '' && server_errors[attribute.attribute_code]"
          >
            <template
              v-if="server_errors[attribute.attribute_code][0].is_unique"
            >{{ attribute.attribute_name }} bị trùng.</template>
            <template
              v-else-if="server_errors[attribute.attribute_code][0].is_required"
            >Không được để trống trường này.</template>
            <template
              v-else-if="server_errors[attribute.attribute_code].not_exist"
            >{{ attribute.attribute_name }} đã bị xóa, vui lòng tải lại trang.</template>
            <template v-else>{{ server_errors[attribute.attribute_code][0] }}</template>
          </div>

          <div
            class="form-control-feedback m--font-danger"
            v-else-if="errors.has(scope + '.' + attribute.attribute_code)"
          >
            <div v-for="(error, indexA) in errors.items" :key="indexA">
              <template v-if="errors.items.length > 0">
                <template
                  v-if="attribute.attribute_code == error.field && error.rule == 'required'"
                >Không được để trống trường này.</template>
                <template v-if="attribute.attribute_code == error.field && error.rule == 'max'">
                  <template v-if=" attribute.data_type.id == isPrice">Giới hạn 20 ký tự.</template>
                  <template v-else-if=" attribute.data_type.id == isTextArea">Giới hạn 1025 ký tự.</template>
                  <template v-else>Giới hạn 250 ký tự.</template>
                </template>

                <template v-if="attribute.attribute_code == error.field && error.rule == 'regex'">
                  Định dạng
                  <span class="text-lowercase">{{ attribute.attribute_name }}</span> không đúng.
                </template>

                <template
                  v-if="attribute.attribute_code == error.field && error.rule == 'numeric'"
                >Giá chỉ được điền số >= 0.</template>
              </template>
            </div>
          </div>
        </template>
      </div>
    </div>
  </draggable>
</template>
